'use strict';

var _commander = require('commander');

var _commander2 = _interopRequireDefault(_commander);

var _version = require('../version');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var program = _commander2.default;

program.version((0, _version.version)());

program.command('init', '初始化配置文件 .vuexrc');

program.command('new', '创建一个新的 vuex 项目');

// fake an alias for generate since commander doesn't support
// aliases for sub-commands.
program.command('generate', '基于Blueprints模板创建结构').command('g', 'generate 的别名');

program.command('server', '开启开发服务器');

program.command('compile', '编译代码');

program.on('--help', function () {
  console.log('  Examples:');
  console.log('');
  console.log('    $ vuex init --help');
  console.log('    $ vuex new my-vuex-project');
  console.log('    $ vuex g component MyComponent');
  console.log('  **** new:');
  console.log('    $ vuex server');
  console.log('    $ vuex compile');
  console.log('');
});

program.parse(process.argv);