'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _shelljs = require('shelljs');

var _subCommand = require('../models/sub-command');

var _subCommand2 = _interopRequireDefault(_subCommand);

var _createAndStepIntoDirectory = require('../tasks/create-and-step-into-directory');

var _createAndStepIntoDirectory2 = _interopRequireDefault(_createAndStepIntoDirectory);

var _gitPull = require('../tasks/git-pull');

var _gitPull2 = _interopRequireDefault(_gitPull);

var _projectSettings = require('../models/project-settings');

var _projectSettings2 = _interopRequireDefault(_projectSettings);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var New = function (_SubCommand) {
  _inherits(New, _SubCommand);

  function New() {
    _classCallCheck(this, New);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(New).call(this));

    _this.createDirTask = new _createAndStepIntoDirectory2.default(_this.environment);
    _this.gitPullTask = new _gitPull2.default(_this.environment);
    return _this;
  }

  _createClass(New, [{
    key: 'printUserHelp',
    value: function printUserHelp() {
      this.logger.write('命令用于创建一个新的vuex项目');
    }
  }, {
    key: 'run',
    value: function run(cliArgs) {
      var _this2 = this;

      this.confirmGit();
      this.createDirTask.run(cliArgs).then(function () {
        var fetch_url = 'https://github.com/sokis/vue-vuex-starter-kit.git';

        _this2.gitPullTask.run(fetch_url).then(function () {
          _this2.createProjectSettings();
          _this2.resetGitHistory();
        });
      });
    }
  }, {
    key: 'confirmGit',
    value: function confirmGit() {
      if (!(0, _shelljs.which)('git')) {
        this.logger.writeError('运行该脚本需要你安装Git.');
        this.logger.writeInfo('如果你有安装Homebrew，请试试运行: brew install git');
        process.exit(1);
      }
    }

    // Should maybe prompt user for permission to do this since it's dangerous.

  }, {
    key: 'resetGitHistory',
    value: function resetGitHistory() {
      this.logger.writeInfo('移除 Staret Kit项目的 .git 文件夹');
      (0, _shelljs.rm)('-rf', '.git');
      (0, _shelljs.exec)('git init && git add -A && git commit -m"Initial commit"', {
        silent: true
      });
      this.logger.writeCreate('创建新的 .git 到的项目中');
      this.logger.writeInfo('恭喜！新的vuex项目已经创建成功。接下来你可以配置CLI并继续使用它');
    }

    // 创建.vuexrc到新的vuex项目中。

  }, {
    key: 'createProjectSettings',
    value: function createProjectSettings() {
      this.logger.writeInfo('创建默认的.vuexrc文件到项目中');
      var vuexStarterKitTemplate = '../../templates/.starterrc';
      var settings = new _projectSettings2.default(vuexStarterKitTemplate);
      settings.save();

      this.logger.writeCreate('保存.vuexrc设置.');
    }
  }]);

  return New;
}(_subCommand2.default);

exports.default = New;